#ifndef GAMEELEMENTS_H
#define GAMEELEMENTS_H

#include <SDL2/SDL_image.h>
#include <stdio.h>
#include <stdlib.h>

void flipX(SDL_Surface * surface);
class Object
{
public:
    double originx;
    double x;
    double y;
    double dx;
    double dy;
    unsigned int animState;
    unsigned int animFrame;
    int timerCounter;
    bool right;
    inline Object(int x=0,int y=0,int dx=0,int dy=0)
    {
        this->timerCounter = 0;
        this->animFrame = 0;
        this->animState = 0;
        this->originx = x;
        this->x = x;
        this->y = y;
        this->dx = dx;
        this->dy = dy;
    }
    void UpdateAi();


    inline bool die()
    {
        if(animState!=2)
        {
            animState=2;
            animFrame=0;
            return true;
        }
        return false;
    }
    inline bool isDied()
    {
        if(animState==2 && animFrame>>4>8)
        {
            return true;
        }
        return false;
    }
};

class Demon
{
public:
    int type;
    double x;
    double y;
    double dx;
    double dy;
    double tx;
    double ty;
    unsigned int aiState;
    unsigned int animFrame;
    // 0,trzymaj sie gory
    // 1,atakuj target
    // 2,ginie

    int timerCounter;

    bool right;
    bool died;
    bool hitEnter;
    inline Demon(int type=0,int x=0,int y=0,int dx=0,int dy=0)
    {
        this->died=false;
        this->type=type;
        timerCounter=0;
        animFrame=0;
        this->tx=x;
        this->ty=y;
        this->x=x;
        this->y=y;
        this->dx=dx;
        this->dy=dy;
        this->aiState=0;
        this->hitEnter=false;
    }
    inline bool die()
    {
        if(!died)
        {
            timerCounter=60;
            aiState=2;
            died=true;
            return true;
        }
        return false;
    }
    inline bool isDied()
    {
        return aiState==2&&timerCounter<0;
    }

    void UpdateAi(bool Aggresive,double tx,double ty);

};


class IIMAGE
{
public:
    SDL_Surface * surface;
    inline IIMAGE(const char * path = 0, bool flip=false)
    {
        surface = 0;
        load(path,flip);
    }
    inline void load (const char * path,bool flip=false)
    {
        if(surface)
        {
            SDL_FreeSurface(surface);
            surface = 0;
        }
        if(path)
        {
            puts(path);
            surface = IMG_Load(path);
            if(surface)
                puts("ok");


            SDL_Surface * opt = SDL_CreateRGBSurface(0,surface->w,surface->h,32,0x00FF0000,0x0000FF00,0x000000FF,0xFF000000);
            SDL_BlitSurface(surface,0,opt,0);
            SDL_FreeSurface(surface);
            surface=opt;
        }

        if(flip)
            flipX(surface);


    }

    inline void own(SDL_Surface * s)
    {
        surface=s;
    }

    inline ~IIMAGE()
    {
        if(surface)
        {
            SDL_FreeSurface(surface);
        }
    }
};

class Particl
{
public:
    double r;
    double x;
    double y;
    double dx;
    double dy;
    double v;
    int life;
    unsigned int color;
    inline Particl(double x=0.0,double y=0.0,unsigned color=0xFF000000,unsigned int life=60)
    {
        this->x=x;
        this->y=y;
        this->color=color;
        this->life=life;
        this->r=rand()*6.28/float(RAND_MAX);
        this->v=1.0;
        this->dy=0;
        this->dx=0;
    }
    inline void Update()
    {
        dx+=((rand()&2)-1)*0.1;
        dy+=((rand()&2)-1)*0.1;
        dx*=0.8;
        dy*=0.8;
        x+=dx;
        y+=dy;
        this->life--;
    }
};



class Przedmiot
{
public:
    double x;
    double y;
    double dx;
    double dy;
    bool active;
    SDL_Surface * surface;
    inline Przedmiot(double x,double y)
    {
        surface=0;
        this->x = x;
        this->y = y;
        dx=0.0;
        dy=0.0;
        active=false;
    }
    inline void activate()
    {
        active=true;
    }
    inline void Update()
    {
        if(active)
        {
            y+=dy;
            dy+=1;
            dy*=0.9;
            if(y>410)
            {
                y=410;
                //dy=-dy*0.5;
            }
        }
    }
};














#endif // GAMEELEMENTS_H
