#ifndef TTFMEM_H_INCLUDED
#define TTFMEM_H_INCLUDED
#include <SDL2/SDL_ttf.h>
struct TTFMem
{
    int asize;
    char*fontFileData;
    int length;

    TTF_Font * font;
    SDL_RWops*io;

    inline TTFMem()
    {
        io=0;
        asize=-1;
        font=0;
        fontFileData=0;
    }
    inline TTFMem(const char *filepath)
    {
        io=0;
        asize = -1;
        font = 0;
        fontFileData=0;
        loadFromFile(filepath);
    }
    inline char* loadFromFile(const char *filepath)
    {
        io=SDL_RWFromFile(filepath,"rb");
        if(io)
        {
            length=SDL_RWseek(io,0,RW_SEEK_END);
            SDL_RWseek(io,0,RW_SEEK_SET);
            if(fontFileData)
                delete[]fontFileData;
            fontFileData=new char[length];
            SDL_RWread(io,fontFileData,1,length);
            SDL_RWclose(io);
            io=0;
            return fontFileData;
        }
        return 0;
    }
    inline TTF_Font *getfont(int size)
    {
        if(size==asize)
            return font;
        if(font)
            TTF_CloseFont(font);
        if(io)
            SDL_RWclose(io);
        io=0;
        font=0;
        if(fontFileData)
        {
            io=SDL_RWFromMem(fontFileData,length);
            font=TTF_OpenFontRW(io,0,size);

            asize=size;
            return font;
        }
        asize=-1;
        return 0;
    }
    inline ~TTFMem()
    {
        /*if(font)
            TTF_CloseFont(font);
        if(io)
            SDL_RWclose(io);*/
        if(fontFileData)
            delete[]fontFileData;
    }

};


#endif // TTFMEM_H_INCLUDED
