#include <SDL2/SDL.h>
#include <stdio.h>
#include "GameElements.h"
#include <math.h>
#include <vector>
#include <stdlib.h>
#include <time.h>
#include "TTFMem.h"
#include "SoundClass.h"
#include "assets.h"


int moralnosc=0;
Object playerObject;
static SoundClass soundObject;

std::vector<Object> ludzie={};

std::vector<Demon> demony={};

std::vector<Particl> particle={};

Przedmiot przedmiot(0,0);

enum BindKeys
{
    K_LEFT,
    K_RIGHT,
    K_UP,
    K_DOWN,
    K_A,
    K_B,
    K_C,
    K_D,
    KEYBINDS_NUM
};

unsigned int keybinds[KEYBINDS_NUM]=
{
    SDLK_LEFT, SDLK_RIGHT, SDLK_UP, SDLK_DOWN,
    SDLK_z, SDLK_x, SDLK_c, SDLK_v
};

unsigned int keysState1[KEYBINDS_NUM];
unsigned int keysState2[KEYBINDS_NUM];



int anim=0;

//static int yup=110;
static int ydown=410;

double CameraPositionX=0;
double CameraPositionY=0;

double CameraShake=0.0;
void ShakeCamera(double m)
{
    CameraShake=m;
}

double glitchValue=0.0;
void GenerateGlitch(double m)
{
    glitchValue=m;
}
int goodness=0;
void setGoodness(int g)
{
    goodness=g;
}

SDL_Surface * napisSurface[64];
void init()
{

    TTF_Init();
    SDL_Color color;
    color.r=255;
    color.g=255;
    color.b=255;
    color.a=255;
    //napisSurface = TTF_RenderUTF8_Blended_Wrapped(memfont.getfont(36),"Bardzo długi różowy napis który nie zmieści się w jednej linii.",color,800-10-10);
    for(int i=0;i<64;i++)
    {
        napisSurface[i]=0;
    }

    napisSurface[0] = TTF_RenderUTF8_Blended_Wrapped(memfont.getfont(36),"Press X to eat",color,800-400);
    napisSurface[1] = TTF_RenderUTF8_Blended_Wrapped(memfont.getfont(36),"Press Z to jump",color,800-400);
    napisSurface[2] = TTF_RenderUTF8_Blended_Wrapped(memfont.getfont(36),"???",color,800-400);
    napisSurface[10]= TTF_RenderUTF8_Blended_Wrapped(memfont.getfont(18),
"Z tą oto chwilą, w której twoje oczy spoczęły na nagrobku, kiedy otarłeś zamszoną płytę i odczytałeś inicjały na niej wyryte, pragnę odkryć przed tobą tajemnicę twojej prawdziwej formy.."
"..istota, do której próbowałeś się upodobnić od zawsze była tobą.."
"..z chwilą, w której uwolniłeś swą duszę z pęt wszechogarniającej marności unicestwiając przeklęte demony, zasłużyłeś na drugą szansę.."
"..odrzuć swój dotychczasowy wizerunek.. odrodź się na nowo.. Powstań i żyj godnie!"
,color,700);
/*napisSurface[11]= TTF_RenderUTF8_Blended_Wrapped(memfont.getfont(18),
"Z tą oto chwilą, w której twoje oczy spoczęły na nagrobku, kiedy otarłeś zamszoną płytę i odczytałeś inicjały na niej wyryte, pragnę odkryć przed tobą tajemnicę twojej prawdziwej formy.."
"..istota, do której próbowałeś się upodobnić od zawsze była tobą.."
"..decydując się odebrać życie tak wielu niewinnym bytom ziemskim, odbieram ci resztki twej ludzkiej świadomości pozostawiając twoją naturę mordercy i chęć niszczenia.."
"..Od teraz będziesz służył ciemności w tej apokalipsie po kres swych dni.."
,color,700);*/





    napisSurface[20]= TTF_RenderUTF8_Blended_Wrapped(memfont.getfont(18),
"\" ..Gdzie jestem..?\n"
"..Czym jestem..? \"\n"
"\n"
"Z tymi słowami wyłaniasz się z odmętów ciemności..\n"
"Samotny.. Porzucony.. Odmienny..\n"
"Zauważasz, zbliżającą się do ciebie nieznaną postać..\n"
"\n"
"\" ..Kim on jest..? \" myślisz\n"
"\n"
"Gdy nagle w jaskini rozlega się głęboki, niski głos starca:\n"
"\n"
"\" Bezkształtny bycie w czerni, przystań na chwilę i posłuchaj moich słów.\n"
"Mam dla ciebie propozycję, obok której nie sposób przejść obojętnie.\n"
"Oferuję ci nieograniczone moce, na tyle potężne, że mogą zniszczyć cały świat.\n"
"Aby je posiąść musisz uśmiercić wystarczająco dużo istnień. \n"
"Wyjdź na powierzchnię i zdecyduj, którą ścieżką będziesz podążał..\"\n"
"\n\n\n                              Wciśnij Spację"
,color,700);


}
void deinit()
{
    TTF_Quit();

    for(int i=0;i<64;i++)
    {
        if(napisSurface[i])
            SDL_FreeSurface(napisSurface[i]);
    }
}

bool wyswietlNapis=false;
SDL_Surface * napisDoWyswietlenia;


inline int max(int a,int b)
{
    return a>b?a:b;
}
inline int min(int a,int b)
{
    return a<b?a:b;
}

void generateParticlesFromSurface(SDL_Surface*src,double x,double y)
{
    unsigned int* pixels=(unsigned int*)(src->pixels);
    int rx,ry;
    for(int i=0;i<100;i++)
    {
        rx=rand()%src->w;
        ry=rand()%src->h;
        if(pixels[ry*src->w + rx]&0xFF000000)
        {
            particle.push_back(Particl(x+rx,y+ry,pixels[ry*src->w + rx]));
        }
    }
}
int stagenumber;
void setKills(int);
int kills;
IIMAGE * outroi=0;
void initStage(int stage)
{
    if(stage==-1)
    {
        stagenumber=-1;
    }
    else if(stage==3)
    {
        stagenumber=stage;
        soundObject.selectMusic(&(musics[stagenumber]));
        demony.clear();
        ludzie.clear();
        particle.clear();

        if(outroi)
            delete[]outroi;
        outroi=new IIMAGE[42];
        for(int i=0;i<42;i++)
        {
            char path[32];
            sprintf(path,"./data/outro/png/%d.png",i+1);
            outroi[i].load(path);
        }


    }
    else
    {
        stagenumber=stage;
        soundObject.selectMusic(&(musics[stagenumber]));
        playerObject.x=70;
        playerObject.y=410;
        playerObject.dx=0;
        playerObject.dy=0;
        demony.clear();
        ludzie.clear();
        particle.clear();
        Przedmiot t(3200,0);

        przedmiot=t;
        kills=0;
        setKills(0);
    }
}
bool isLevelEnding=false;
int levelEndingTimer=0;
unsigned int levelEndNextLevel=0;
void levelEnd(unsigned int nextLevel)
{
    soundObject.stopMusic();
    if(isLevelEnding==false)
    {
        isLevelEnding=true;
        levelEndingTimer=60;
        levelEndNextLevel=nextLevel;
    }
}
void levelEndTick()
{

    if(isLevelEnding==true)
    {
        levelEndingTimer--;
        if(levelEndingTimer<0)
        {
            isLevelEnding=false;
            initStage(levelEndNextLevel);
        }
    }
}
void setKills(int k)
{
    TTF_Init();
    SDL_Color color;
    color.r=255;
    color.g=0;
    color.b=0;
    color.a=255;

    char asd[16];
    sprintf(asd,"Souls: %d/30",k);
    SDL_FreeSurface(napisSurface[3]);
    napisSurface[3] = TTF_RenderUTF8_Blended_Wrapped(memfont.getfont(36),asd,color,800-400);
}
void gameTick()
{
    wyswietlNapis=false;
    CameraShake-=0.02;
    if(CameraShake<0.0)CameraShake=0.0;

    glitchValue-=1;
    if(glitchValue<0.0)glitchValue=0.0;

    if(goodness>0)goodness--;
    if(goodness<0)goodness++;


    if(glitchValue>0.0)
    {
        soundObject.gv=1+rand()%int(ceil(glitchValue));
    }
    else
    {
        soundObject.gv=0;
    }

    {
        const unsigned char* state = SDL_GetKeyboardState(NULL);
        for(int i=0; i<KEYBINDS_NUM; i++)
        {
            keysState2[i] = keysState1[i];
            keysState1[i] = state[SDL_GetScancodeFromKey(keybinds[i])] ;
        }
    }

    int fx=0;
    if(keysState1[K_LEFT])
    {
        playerObject.dx-=1;
        fx--;
    }

    if(keysState1[K_RIGHT])
    {
        playerObject.dx+=1;
        fx++;
    }
    if(fx>0)
        playerObject.right=true;
    if(fx<0)
        playerObject.right=false;

    if(playerObject.x<70)
        playerObject.x=70;
    if(playerObject.x>3800-70)
        playerObject.x=3800-70;

    {
        static float jumpStr=0;
        if(playerObject.y==ydown)
        {
            jumpStr=-13;
        }
        if(keysState1[K_A] && !keysState2[K_A])
        {
            playerObject.dy=jumpStr;
            jumpStr*=0.5;
        }
    }
    if(playerObject.y<90)
    {
        playerObject.y=90;
        playerObject.dy=0;
    }

    playerObject.dy+=0.3;
    playerObject.x+=playerObject.dx;
    playerObject.y+=playerObject.dy;
    playerObject.dx*=0.7;
    playerObject.dy*=0.99;


    if(playerObject.y>ydown)
        playerObject.y=ydown;
    {
        static int t=0;
        t++;
        if(t%100==0)
        {
            if(ludzie.size()<5)
            {
                double newLudzX=((rand()&2)-1)*500 +rand()%100-50;
                ludzie.push_back(Object(playerObject.x+newLudzX,410));
            }

            if(demony.size()<5)
            {
                demony.push_back(Demon(rand()&1,playerObject.x+(rand()%800)-400,-50));
            }
        }
    }

    //particle.push_back(Particl(playerObject.x,playerObject.y));
    //generateParticlesFromSurface(playerLeft[0].surface,playerObject.x-73,playerObject.y-90);
    for(std::vector<Object>::iterator it=ludzie.begin();it!=ludzie.end();)
    {
        it->UpdateAi();
        bool bbox=(it->x -20  < playerObject.x + 73 && it->x + 20 > playerObject.x - 73 ) &&
           (it->y - 150 < playerObject.y && it->y  > playerObject.y - 90 );

        if(bbox&& !(keysState1[K_B] && !keysState2[K_B]))
        {
            wyswietlNapis=true;
            napisDoWyswietlenia=napisSurface[0];
        }
        if(bbox && (keysState1[K_B] && !keysState2[K_B]))
        {
            if(it->die())
            {
                kills++;

                //ShakeCamera(0.5);
                soundObject.playSfx(&(sfxs[rand()%4]));
                moralnosc-=15;

                if(moralnosc<0)
                {
                    GenerateGlitch(-moralnosc);
                    setGoodness(max(-128,moralnosc*2));
                }
            }
        }
        if(it->isDied() || (it->x<playerObject.x-600 || it->x>playerObject.x+600 ))
        {
            it=ludzie.erase(it);
        }
        else
            it++;
    }
    for(std::vector<Demon>::iterator it=demony.begin();it!=demony.end();)
    {
        it->UpdateAi(moralnosc>128,playerObject.x,playerObject.y);
        bool bbox=(it->x -73  +10< playerObject.x + 73 -10&& it->x + 73 -10> playerObject.x - 73 +10) &&
           (it->y - 45 +10 < playerObject.y -10&& it->y+45  -10> playerObject.y - 90 +10);

        if(bbox&& !(keysState1[K_B] && !keysState2[K_B]))
        {
        }
        if(bbox&&it->aiState==1 && !it->hitEnter)
        {
            ShakeCamera(0.5);
            soundObject.playSfx(&(sfxs[7]));
            it->hitEnter=true;
            kills--;
        }
        if(!bbox)
        {
            it->hitEnter=false;
        }
        if(bbox && (keysState1[K_B] && !keysState2[K_B]))
        {
            if(it->die())
            {
                kills++;
                //ShakeCamera(0.5);
                soundObject.playSfx(&(sfxs[4+rand()%3]));
                moralnosc+=15;
                moralnosc=(max(0,moralnosc));

            }

        }
        if(it->isDied()|| (it->x<playerObject.x-600 || it->x>playerObject.x+600 ))
        {
            it=demony.erase(it);
        }
        else
            it++;
    }
    for(std::vector<Particl>::iterator it=particle.begin();it!=particle.end();)
    {
        if((it->life)<0 )
        {
            it=particle.erase(it);
        }
        else
        {
            it->Update();
            it++;
        }
    }

    //przedmiot
    przedmiot.Update();
    {
        bool bbox=(przedmiot.x -25  < playerObject.x + 73 -10 && przedmiot.x +25 > playerObject.x - 73 +10) &&
           (przedmiot.y - 50  < playerObject.y -10 && przedmiot.y> playerObject.y - 90 +10);
           if(bbox)
           {
               wyswietlNapis=true;
               napisDoWyswietlenia=(napisSurface[2]);
               if(keysState1[K_B] && !keysState2[K_B])
               {

                   levelEnd(stagenumber+1);
               }
           }
    }


    moralnosc=max(-255,min(255,moralnosc));
    CameraPositionX += (playerObject.x-400 + playerObject.dx*96.0 - CameraPositionX)*0.03;
    if(CameraPositionX<0)
    {
        CameraPositionX=0;
    }

    if(CameraPositionX>3000)
    {
        CameraPositionX=3000;
    }
    anim++;
    kills=max(0,min(30,kills));
    {
        static int last=-1;
        if(last!=kills)
        {
            last=kills;
            setKills(last);
        }
    }
    if(kills==30)
    {
        if(!przedmiot.active)
        {
            przedmiot.activate();
            przedmiot.x=CameraPositionX+rand()%600+100;
            if(przedmiot.x<25)
                przedmiot.x=25;
            if(przedmiot.x>3800-25)
                przedmiot.x=3800-25;

        }

    }
    levelEndTick();
}

void lightShift(SDL_Surface * surface, int a)
{
    unsigned int* pixels=(unsigned int*)(surface->pixels);
    int addr=0;

    for(int y=0;y<surface->h;y++)
    {
        for(int x=0;x<surface->w;x++)
        {
            unsigned int color = pixels[addr];
            unsigned char *c=(unsigned char*)&color;
            c[0]=min(255,max(0,c[0]+a));
            c[1]=min(255,max(0,c[1]+a));
            c[2]=min(255,max(0,c[2]+a));

            pixels[addr]=color;
            addr++;
        }
    }

}

void blur(SDL_Surface *surface,int a)
{
    unsigned int* pixels=(unsigned int*)(surface->pixels);
    int addr=0;

    for(int y=0;y<surface->h;y++)
    {
        unsigned int filter=0;;
        unsigned char *f=(unsigned char*)&filter;
        for(int x=0;x<surface->w;x++)
        {
            unsigned int color = pixels[addr];

            unsigned char *c=(unsigned char*)&color;
            f[0]+=(c[0]-f[0])>>a;
            f[1]+=(c[1]-f[1])>>a;
            f[2]+=(c[2]-f[2])>>a;

            pixels[addr]=filter;
            addr++;
        }
    }

}

unsigned int moralToColor(int moral)
{
    float x=moral/100.0;
    float r,g,b;
    if(x>0)
    {
        r=1.0-x;
        g=1.0;
        b=1.0-x;
    }
    else
    {
        x=-x;
        r=1.0;
        g=1.0-x;
        b=1.0-x;
    }
    int _r=r*255,_g=g*255,_b=b*255;
    return (_b<<0) | (_g<<8) | (_r<<16) | 0xFF000000;
}

void glitch(SDL_Surface * surface)
{
    unsigned int* pixels=(unsigned int*)(surface->pixels);
    int ard=0;
    int awr=0;

    for(int y=0;y<surface->h;y++)
    {
        for(int x=0;x<surface->w;x++)
        {
            unsigned int color = pixels[ard];


            pixels[awr]=color;
            if(rand()&65535)
                awr++;
            if(rand()&65535)
                ard++;
        }
    }
}

void drawPixel(SDL_Surface * surface, int x, int y, unsigned int color)
{
    if(x<0||y<0||x>=surface->w||y>=surface->h)return;


    unsigned int*pixels=(unsigned int*)surface->pixels;
    pixels[y*surface->w + x] = color;

}
void renderTick(SDL_Surface *surface)
{
    double CameraX = CameraPositionX;
    double CameraY = CameraPositionY;
    {
        double r= rand()*6.28 /(double)RAND_MAX;
        CameraX += cos(r)*CameraShake*100.0;
        CameraY += sin(r)*CameraShake*100.0;
    }


    //tlo
    {
        SDL_Rect r2;
        double tgcx=fmod(CameraX,backgrounds[stagenumber].surface->w);
        r2 = {
            int(0.0 - tgcx),
            int(-CameraY),
            0,0};
        SDL_BlitSurface(backgrounds[stagenumber].surface, 0, surface, &r2);
        r2 = {
            int(0 - tgcx + backgrounds[stagenumber].surface->w),
            int(-CameraY),
            0,0};

        SDL_BlitSurface(backgrounds[stagenumber].surface, 0, surface, &r2);
    }


    //ludzie
    for(Object o:ludzie)
    {
        IIMAGE * s;
        int a;
        if(o.animState!=2)// not dying
        {
            a = (o.animFrame>>3)%15;
            s = o.right?ludekRight:ludekLeft;
        }
        else
        {
            a = (o.animFrame>>4)%9;
            s = o.right?ludekRightDying:ludekLeftDying;
        }

        SDL_Rect r2 = {
            int(o.x - (s[a].surface->w>>1)  - CameraX ),
            int(o.y - s[a].surface->h - CameraY ),
            0,0};

        SDL_BlitSurface(s[a].surface, 0, surface, &r2);
        if(o.animState==2)
            generateParticlesFromSurface(s[a].surface,o.x - (s[a].surface->w>>1),o.y - s[a].surface->h );

    }

    for(Demon o:demony)
    {
        int a;
        IIMAGE *s;
        switch(o.type)
        {
            case 0:
                a = (o.animFrame>>3)%9;
                s = o.right?demonRight:demonLeft;
                break;

            case 1:
                a = (o.animFrame>>3)%6;
                s = o.right?demonekRight:demonekLeft;
                break;
            default:
                s=0;
                a=0;
        }

        SDL_Rect r2 = {
            int(o.x - (s[a].surface->w>>1) - CameraX ),
            int(o.y - (s[a].surface->h>>1) - CameraY ),
            0,0};

        SDL_BlitSurface(s[a].surface, 0, surface, &r2);
        if(o.aiState==1||o.aiState==2)
            generateParticlesFromSurface(s[a].surface,
                                         o.x - (s[a].surface->w>>1),
                                         o.y - (s[a].surface->h>>1) );


    }
    //przedmiot
    {
        SDL_Rect r2;

         SDL_Surface * s = pddd[stagenumber].surface;
        r2 = {
            int(przedmiot.x - CameraX - 25),
            int(przedmiot.y - CameraY -50),
            0,0};
        SDL_BlitSurface(s, 0, surface, &r2);
    }
    //player
    {
        SDL_Rect r2;
        int a = (anim>>3)%8;

        IIMAGE * ludek = playerObject.right?playerRight:playerLeft;
        r2 = {
            int(playerObject.x - CameraX - (ludek[a].surface->w>>1)),
            int(playerObject.y-ludek[a].surface->h- CameraY),
            0,0};
        SDL_BlitSurface(ludek[a].surface, 0, surface, &r2);
    }

    for(Particl p:particle)
    {
        //drawPixel(surface,p.x-CameraX,p.y-CameraY,p.color);
        SDL_Rect r={int(p.x-CameraX)-1,int(p.y-CameraY)-1,3,3};
        SDL_FillRect(surface,&r,p.color);
    }



    {
        SDL_Rect r;

        r= {0,0-200-int(CameraY),800,200};
        SDL_FillRect(surface,&r,0);
        r= {
            0,
            int(ydown+50-CameraY),
            //int(ydown+50),
            800,600};
        SDL_FillRect(surface,&r,0);
    }
    //morlanosc pasek
    {
        SDL_Rect r;

        r= {600,500+5,150,30};
        unsigned char c=(max(0,moralnosc));
        SDL_FillRect(surface,&r, c<<0|c<<8|c<<16|c<<24);
    }

    if(wyswietlNapis)
    {
        SDL_Rect r2;
        r2 = {10,ydown+50,0,0};
        SDL_BlitSurface(napisDoWyswietlenia, 0, surface, &r2);
    }
    if(napisSurface[3])
    {
        SDL_Rect r2;
        r2 = {10,ydown+140,0,0};
        SDL_BlitSurface(napisSurface[3], 0, surface, &r2);
    }

    //if(glitchValue>0.0)
    //    glitch(surface);
    //if(goodness)
    lightShift(surface,goodness);
    blur(surface,1+min(max(-goodness>>2,0),5));
    if(isLevelEnding)
    {
        blur(surface,(60-levelEndingTimer)>>3);
    }

}

int main(int argc,char **argv)
{
    playerObject.x=400.0;
    srand(time(0));
    SDL_Init(SDL_INIT_EVERYTHING);
    SDL_Window*window=SDL_CreateWindow("",SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED,800,600,SDL_WINDOW_RESIZABLE|SDL_WINDOW_MAXIMIZED);
    SDL_Event event;

    soundObject.sdl_init();
    init();

    bool running=true;

    unsigned int frameNumber=0;
    SDL_Surface * gameSurface=SDL_CreateRGBSurface(0,800,600,32,0,0,0,0);

    SDL_BlitSurface(napisSurface[20],0,backgrounds[4].surface,0);
    initStage(-1);
    unsigned napisoutroa=0;
    while(running)
    {
        while(SDL_PollEvent(&event))
        {
            switch(event.type)
            {
            case SDL_QUIT:
                running=false;
                break;
            case SDL_KEYDOWN:
                switch(event.key.keysym.sym)
                {
                case SDLK_ESCAPE:
                    running=false;

                case SDLK_F1:
                    initStage(0);
                    break;
                case SDLK_F2:
                    initStage(1);
                    break;
                case SDLK_F3:
                    initStage(2);
                    break;
                case SDLK_F4:
                    initStage(3);
                    break;
                case SDLK_F5:
                    initStage(4);
                    break;
                case SDLK_SPACE:
                    if(stagenumber==-1)
                        initStage(0);
                    if(stagenumber==3)
                    {
                        napisoutroa++;
                    }
                    break;


                case SDLK_F11:
                    {
                        static bool fullscreen=false;
                        fullscreen=!fullscreen;
                        if(fullscreen)
                            SDL_SetWindowFullscreen(window,SDL_WINDOW_FULLSCREEN_DESKTOP);
                        else
                            SDL_SetWindowFullscreen(window,0);
                    }
                }
                break;
            }
        }
        if(stagenumber ==-1)
        {
            SDL_Surface * surface = SDL_GetWindowSurface(window);
            SDL_Surface * gameSurface = backgrounds[4].surface;

            double scalew=double(surface->w)/double(gameSurface->w);
            double scaleh=double(surface->h)/double(gameSurface->h);
            double scale=scalew>scaleh?scaleh:scalew;


            SDL_Rect r2={
                (surface->w - int(gameSurface->w*scale))>>1,(surface->h - int(gameSurface->h*scale))>>1,
            int(gameSurface->w*scale),int(gameSurface->h*scale)};
            SDL_BlitScaled(gameSurface,0,surface,&r2);
            SDL_UpdateWindowSurface(window);
        }
        else if(stagenumber>=0 && stagenumber<3)
        {
            unsigned int tf = SDL_GetTicks()*120/1000;
            int n=tf-frameNumber;
            frameNumber=tf;
            if(n>10)n=10;

            for(int i=0; i<n; i++)
                gameTick();


            if(n>0)
            {
                SDL_Surface * surface = SDL_GetWindowSurface(window);
                SDL_FillRect(surface,0,0);
                renderTick(gameSurface);
                double scalew=double(surface->w)/double(gameSurface->w);
                double scaleh=double(surface->h)/double(gameSurface->h);
                double scale=scalew>scaleh?scaleh:scalew;


                SDL_Rect r2={
                    (surface->w - int(gameSurface->w*scale))>>1,(surface->h - int(gameSurface->h*scale))>>1,
                int(gameSurface->w*scale),int(gameSurface->h*scale)};
                SDL_BlitScaled(gameSurface,0,surface,&r2);
                SDL_UpdateWindowSurface(window);
            }
        }
        else if(stagenumber==3)
        {
            static int outroframe=0;
            SDL_Surface * surface = SDL_GetWindowSurface(window);
            SDL_FillRect(surface,0,0);
            SDL_Surface * gameSurface;
            if(napisoutroa==0)
            {
                gameSurface = napisSurface[10];
            }
            else if(napisoutroa==1)
            {
                gameSurface = outroi[outroframe].surface;
                unsigned int tf = SDL_GetTicks()*5/1000;
                if(tf!=frameNumber)
                {
                    frameNumber=tf;
                    outroframe++;
                }
                if(outroframe==42)
                {
                    napisoutroa++;
                }
            }
            else if(napisoutroa==2)
            {
                gameSurface = outroi[41].surface;

            }
            else
                gameSurface=0;

            double scalew=double(surface->w)/double(gameSurface->w);
            double scaleh=double(surface->h)/double(gameSurface->h);
            double scale=scalew>scaleh?scaleh:scalew;


            SDL_Rect r2={
                (surface->w - int(gameSurface->w*scale))>>1,(surface->h - int(gameSurface->h*scale))>>1,
            int(gameSurface->w*scale),int(gameSurface->h*scale)};
            SDL_BlitScaled(gameSurface,0,surface,&r2);
            SDL_UpdateWindowSurface(window);


        }
        SDL_Delay(10);
    }
    SDL_FreeSurface(gameSurface);
    delete[]outroi;
    soundObject.sdl_quit();
    deinit();
    SDL_DestroyWindow(window);
    SDL_Quit();
    return 0;
}
